import numpy as np
from ..utility.trainingObservables import Observable, TrainingObservables


class SOMobservable(TrainingObservables):
    """
    The SOMobservable class is used to monitor various metrics during the training of a
    Self-Organizing Map (SOM).
    """
    __slots__ = ['topologyError', 'quantazationError', 'learningRate', 'gridSteps']

    def __init__(self, epochs) -> None:
        super().__init__(epochs)
        self.topologyError = Observable(epochs, colors='descending')
        self.quantazationError = Observable(epochs, colors='descending')
        self.learningRate = Observable(epochs)
        self.gridSteps = Observable(epochs)
